/**

  The Initial Developer of the Original Code is
  Matthieu  - http://www.programmation-facile.com/
  Portions created by the Initial Developer are Copyright (C) 2013
  the Initial Developer. All Rights Reserved.

  Contributor(s) :

 */
package  
{
	import flash.display.MovieClip;
	import flash.display.DisplayObject;
	import com.demonsters.debugger.MonsterDebugger;

	import com.actionscriptfacile.ui.text.UITextField;


	import flash.display.Sprite;
	import flash.events.Event;
	
	
	/**
	 * Exemple d'utilisation tableaux en ActionScript
	 * 
	 * @author Matthieu
	 */
	public class Main extends Sprite
	{				
		
		public function Main() 
		{
			// attend la fin de l'initialisation de la scène
			this.addEventListener(Event.ADDED_TO_STAGE, onReady, false, 0, true);
		}

		/**
		 * Démarrage de l'application.
		 * 
		 */
		protected function onReady(event : Event) : void
		{
			this.removeEventListener(Event.ADDED_TO_STAGE, onReady);
			
			// Init De MonsterDebugger
            MonsterDebugger.initialize(this);
            MonsterDebugger.trace(this, "Manipulation des données");
            
			this.useArray();
			this.multiDimensionalArray();
		}
		
		
		
		/**
		 * Les tableaux à plusieurs dimensions.
		 * Parcourir les tableaux.
		 * 
		 */
		private function multiDimensionalArray() : void
		{			
			var aCountryList:Array = new Array(); 
			aCountryList[0] = ["Californie", "Alabama", "Arizona"]; 
			aCountryList[1] = ["Bretagne", "Auvergne", "Aquitaine", "Isère"]; 
			aCountryList[2] = ["Suisse", "Australie", "Inde"]; 
			aCountryList[3] = ["Japon"]; 
			aCountryList[4] = ["Chine", "Russie"]; 
			
			MonsterDebugger.trace(this, "----> multiDimensionalArray");
			MonsterDebugger.trace(this, "Pays : "+aCountryList[3][0]);// affiche Japon
			MonsterDebugger.trace(this, "Pays : "+aCountryList[4][1]);// affiche Russie
			MonsterDebugger.trace(this, "Pays : "+aCountryList[0]);// affiche le tableau des Etats Unis
			trace("test");
			
			// parcours d'un tableau à plusieurs dimensions
			for (var j : int = 0; j < aCountryList.length; j++)
			{  
				MonsterDebugger.trace(this, "Liste des éléments de la 2ème dimension à la position " + j +" du 1er tableau");
				
				for (var k : int = 0; k < aCountryList[j].length; k++)
				{
					MonsterDebugger.trace(this, "Pays ou Etat : " + aCountryList[j][k]);
				}
			}
			
			MonsterDebugger.trace(this, "parcours rapide d'un tableau à plusiurs dimensions");
			
			// parcours rapide d'un tableau
			for each (var aListEtats : Array in aCountryList)
			{
				for each (var sEtats : String in aListEtats)
				{
					MonsterDebugger.trace(this, "Etat ou Pays : " + sEtats);
				}
			}
			
			
			var aFruits:Array = ['pomme', 'orange', 'banane', 'pêche', 'clémentine'];
			// parcours d'un tableau
			for (var i : int = 0; i < aFruits.length; i++)
			{  
				MonsterDebugger.trace(this, "Position " + i +" du tableau des fruits, il y a " + aFruits[i]);
			}
			
			// recherche dans un tableau
			var sSearch:String = "banane";
			i=0;
			while( i < aFruits.length && sSearch != aFruits[i] )
     		{
				i++;
			}
			trace("Position " + i +" du fruit " + sSearch);
			MonsterDebugger.trace(this, "Position " + i +" du fruit " + sSearch);
			
			// parcours rapide d'un tableau
			for each (var sFruit : String in aFruits)
			{
				MonsterDebugger.trace(this, "Fruit : " + sFruit);
			}
		}


		/**
		 * Utilisation pratique des tableaux.
		 * 
		 */
		private function useArray() : void 
		{
			
			/**
			 * Array.forEach procède à une navigation simple
			 * sur chaque élément à partir d'une fonction dédiée
			 * 
			 */ 
			var aFruits:Array = ['pomme', 'orange', 'banane', 'pêche', 'clémentine'];
			aFruits.forEach(afficheAll);// Permet d'itérer simplement au sein d'un tableau.
			
			/**
			 * la classe Vector est comme la classe Array
			 * la classe Vector est un tableau dont les éléments possèdent tous le même type de données.
			 * plus dinformations sur :
			 * http://help.adobe.com/fr_FR/FlashPlatform/reference/actionscript/3/Vector.html
			 * 
			 * Au niveau des performances :
			 * Dans tous les cas où vous utilisez un objet Array dont tous les éléments possèdent le même type de données, 
			 * il est préférable d'utiliser une occurrence de l'objet Vector.
			 * 
			 */ 
			var vaFruits:Vector.<String> = new <String>['pomme2', 'orange2', 'banane2', 'pêche2', 'clémentine2'];
			vaFruits.forEach(afficheAllVector);// Permet d'itérer simplement au sein d'un tableau.
			
			/**
			 * Array.every
			 * Exécute la fonction de navigation pour trouver le type d'élément et renvoie false.
  		     * Il est donc très facile de déterminer si un tableau contient un type de valeurs attendues.
  		     * 
			 */
			var aData:Array = [12, 'pomme', 'orange', 32, 'banane', 'pêche', 28, 'clémentine'];// déterminer si le tableau contient des nombres
			var bNombres:Boolean = aData.every(testElements);// affiche : false		
			MonsterDebugger.trace(this, "que des nombres dans le tableau aData :"+bNombres);
			
			var aDataN:Array = [12, 32, 28];
			bNombres = aDataN.every(testElements);// affiche : true			
			MonsterDebugger.trace(this, "que des nombres dans le tableau aDataN :"+bNombres);
			
			/**
			 * Array.map
			 * Exécute la fonction de navigation.
  		     * Permet de créer un nouveau tableau.
  		     * 
			 */
			// création d'un nouveau tableau à partir du retour de la fonction affiche.
			var aFruitsFormat:Array = aFruits.map(elementToUpperCase);
			// affiche : Pomme, Orange, Banane
			MonsterDebugger.trace(this, aFruitsFormat);
			
			
			/**
			 * Array.filter
			 * Exécute la fonction de navigation.
  		     * Permet de filtrer les éléments d'un tableau.
  		     * 
			 */
			var aFruitsDetails:Array = [ { fruit : 'pomme', calorie : 48 },
										{ fruit : 'orange', calorie : 40 },
										{ fruit : 'banane', calorie : 94 },
										{ fruit : 'abricots', calorie : 45 },
										{ fruit : 'pêche', calorie : 50 },
										{ fruit : 'clémentine', calorie : 88 }
									] ;
			
			var aFruitsRiches:Array = aFruitsDetails.filter(filterElement);// création d'un nouveau tableau en supprimant les éléments inférieurs à 50 calories
			aFruitsRiches.forEach(afficheAllFruits);									
			
			
			/**
			 * Array.some
			 * Exécute la fonction de navigation.
  		     * Permet de savoir si un élément existe au moins une fois dans un tableau.
  		     * 
			 */
 			var aPersonnes:Array = [ { prenom : 'Nicolas', age : 50, sexe : 'H' },
									{ prenom : 'Frédéric', age : 30, sexe : 'H' },
									{ prenom : 'Alice', age : 28, sexe : 'F' },
									{ prenom : 'Yannick', age : 29, sexe : 'H' } 
								] ;

			var bsearchFemme:Boolean = aPersonnes.some(searchFemme);// affiche true
			MonsterDebugger.trace(this, "une femme dans le tableau aPersonnes :"+bsearchFemme);
			
 			var aPersonnes2:Array = [ { prenom : 'Nicolas', age : 50, sexe : 'H' },
									{ prenom : 'Frédéric', age : 30, sexe : 'H' },
									{ prenom : 'François', age : 28, sexe : 'H' },
									{ prenom : 'Yannick', age : 29, sexe : 'H' } 
								] ;

			bsearchFemme = aPersonnes2.some(searchFemme);// affiche false
			MonsterDebugger.trace(this, "une femme dans le tableau aPersonnes2 :"+bsearchFemme);			
			
			
			/**
			 * Array.indexOf et Array.lastIndexOf
			 * Permet de rechercher si un élément existe et de connaître sa position.
			 * 
			 * indexOf pour la position du 1er élément trouvé.
			 * lastIndexOf pour la position du dernier élément trouvé.
  		     * 
  		     * Possibilité de rechercher un élément de type primitif (number, string) et de type composite (MovieClip, DisplayObject).
			 */
			 
			var aPersonnesListe:Array = [ 'Nicolas', 'Yannick', 'Caroline', 'Yannick', 'Antoine' ];
			
			var positionDebut:int = aPersonnesListe.indexOf('Yannick');
			var positionFin:int = aPersonnesListe.lastIndexOf('Yannick');
			var positionNulle:int = aPersonnesListe.indexOf('François');
			
			MonsterDebugger.trace(this, "1ère position du prénom Yannick :"+positionDebut);// affiche : 1
			MonsterDebugger.trace(this, "dernière position du prénom Yannick :"+positionFin);// affiche : 3
			MonsterDebugger.trace(this, "position (inxistante) du prénom François :"+positionNulle);// élément non trouvé affiche : -1
			 
			/**
			 * utilisé également pour rechercher un élément de type primitif (number, string) et de type composite (MovieClip, DisplayObject).
			 * une recherche par référence d'objets.
			 */ 
			 
			var oDisplay:DisplayObject = new MovieClip();
			var oDisplayAutre:DisplayObject = new MovieClip();
			
			var aTableau:Array = [oDisplay] ;// stock une référence au clip oDisplay dans un tableau
			var positionClip:int  = aTableau.indexOf(oDisplay);
			var positionAutre:int  = aTableau.lastIndexOf(oDisplayAutre);
			
			MonsterDebugger.trace(this, "recherche du clip oDisplay :"+positionClip);// affiche : 0, clip trouvé
			MonsterDebugger.trace(this, "recherche du clip oDisplayAutre :"+positionAutre);// affiche : -1, clip inexistant 
			 
			/**
			 * d'autres fonction utiles sur : 
			 * http://livedocs.adobe.com/flash/9.0_fr/ActionScriptLangRefV3/Array.html
			 * 
			 * splice pour supprimer un élément d'un tableau.
			 * Par exemple var aTableau:Array = aTableauComplet.splice( index, 1); // supprime un seul élément du tableau complet à la position index
			 */ 
			var aTableauComplet:Array = new Array("maison", "voyages", "voiture", "plage", "montagne", "parc");
			var aTabMini:Array = aTableauComplet.splice(2,1); // supprime l'élément voiture -- aTabMini contient l'élément supprimé
			MonsterDebugger.trace(this, "Array splice");
			MonsterDebugger.trace(this, aTableauComplet);
			MonsterDebugger.trace(this, aTabMini);
			
			/**
			 * Il y a aussi les méthodes  push(), pop(), shift(), unshift().
			 * 
			 * La méthode push() ajoute un ou plusieurs éléments à la fin d'un vecteur ou d'un tableau array.
			 * La méthode unshift() ajoute un ou plusieurs éléments au début d'un vecteur ou d'un tableau array
			 * et renvoie la nouvelle longueur du vecteur. 
			 * La méthode pop() supprime le dernier élément du vecteur et renvoie cet élément. La propriété length du vecteur est diminuée d'une unité lorsque cette fonction est appelée
			 * 
			 */
			 
			var avMois:Vector.<String> = new <String>['Janvier', 'Février', 'Mars', 'Avril'];
			avMois.push("Mai");
			avMois.push("Juin", "Juillet");
			MonsterDebugger.trace(this, "Array push");
			MonsterDebugger.trace(this, avMois);
			
			var avDuree:Vector.<int> = new <int>[20, 26, 32, 36];
			var nNbreElts:int = avDuree.push(45, 56, 67);// ajout à la fin du tableau
			MonsterDebugger.trace(this, "Nombre d'éléments dans le vecteur après l'ajout : " + nNbreElts);
			nNbreElts = avDuree.unshift(3, 10);// ajout au début du tableau
			MonsterDebugger.trace(this, "Nombre d'éléments dans le vecteur après l'ajout : " + nNbreElts);
			MonsterDebugger.trace(this, "tableau aevc unshift: ");
			MonsterDebugger.trace(this, avDuree);
		}


		
		/**
		 * Fonction de navigation passée en paramètre d'un tableau
		 * pour itérer et de traiter les données au sein du tableau.
		 * 
		 * Il est possible d'ajouter vos propres traitements pour un affichage de données, remplir un formulaire... 
		 * 
		 * @param element : l'élément du tableau en cours de lecture.
		 * @param index : la position de l'élément dans le tableau.
		 * @param tableau : le tableau complet.
		 * 
		 */
		private function afficheAll (element :*, index:int, tableau:Array):void
		{
		     var sContentTb:String = "Element : "+element + ', position : ' + index + ', contenu : ' + tableau;
			 MonsterDebugger.trace(this, sContentTb);
			 
			 var oText:UITextField = this.addText(sContentTb);
			 oText.y = index * 15;
			 this.addChild(oText);// affiche chaque élément du tebleau dans un champ texte
		}


		/**
		 * Fonction de navigation passée en paramètre d'un tableau
		 * pour itérer et de traiter les données au sein du tableau.
		 * 
		 * Il est possible d'ajouter vos propres traitements pour un affichage de données, remplir un formulaire... 
		 * 
		 * @param element : l'élément du tableau en cours de lecture.
		 * @param index : la position de l'élément dans le tableau.
		 * @param tableau : le tableau complet.
		 * 
		 */
		private function afficheAllVector (element :String, index:int, tableau:Vector.<String>):void
		{
		     var sContentTb:String = "Element : "+element + ', position : ' + index + ', contenu : ' + tableau;
			 MonsterDebugger.trace(this, sContentTb);
			 
			 var oText:UITextField = this.addText(sContentTb);
			 oText.y = 300 + index * 15;
			 this.addChild(oText);// affiche chaque élément du tebleau dans un champ texte
		}		
		
		
		
		/**
		 * Fonction de navigation passée en paramètre d'un tableau
		 * pour itérer et de traiter les données au sein du tableau.
		 * 
		 * Il est possible d'ajouter vos propres traitements pour un affichage de données, remplir un formulaire... 
		 * 
		 * @param element : l'élément du tableau en cours de lecture.
		 * @param index : la position de l'élément dans le tableau.
		 * @param tableau : le tableau complet.
		 * 
		 */
		private function afficheAllFruits (element :*, index:int, tableau:Array):void
		{
		     var sContentTb:String = "Fruit : "+element.fruit + ', Calories : ' + element.calorie;
			 MonsterDebugger.trace(this,sContentTb);
			  
			 var oText:UITextField = this.addText(sContentTb);
			 oText.y = 200 + index * 15;
			 this.addChild(oText);// affiche chaque élément du tebleau dans un champ texte
		}
		
				
		/**
		 * Fonction de navigation passée en paramètre d'un tableau
		 * pour itérer et de traiter les données au sein du tableau.
		 * 
		 * Détermine si un tableau contient un type de valeurs attendues (des nombres)
		 * 
		 * @param element : l'élément du tableau en cours de lecture.
		 * @param index : la position de l'élément dans le tableau.
		 * @param tableau : le tableau complet.
		 * 
		 */
		private function testElements (element :*, index:int, tableau:Array):Boolean
		{
		     return (element is Number);
		}
			
			
			
		/**
		 * Fonction de navigation passée en paramètre d'un tableau
		 * Permet de créer un nouveau tableau.
		 * 
		 * Formatage des caractères  des éléments du tableau : 1ère lettre en majuscule et les autres en minuscules).
		 * 
		 * @param element : l'élément du tableau en cours de lecture.
		 * @param index : la position de l'élément dans le tableau.
		 * @param tableau : le tableau complet.
		 * 
		 */			
		private function elementToUpperCase (element :*, index:int, tableau:Array):String
		{
			 var sText:String = element.charAt(0).toUpperCase()+element.substr(1).toLowerCase();
			 var oText:UITextField = this.addText(sText);
			 oText.y = 100 + index * 15;
			 this.addChild(oText);// affiche chaque élément du tebleau dans un champ texte
			 
			 return sText;
		}	
		
		
		/**
		 * Fonction de navigation passée en paramètre d'un tableau
		 * Permet de créer un nouveau tableau.
		 * 
		 * Pour les filter les éléments d'un tableau
		 * Renvoie uniquement les éléments supérieurs ou égals à 50 calories.
		 * 
		 * @param element : l'élément du tableau en cours de lecture.
		 * @param index : la position de l'élément dans le tableau.
		 * @param tableau : le tableau complet.
		 * 
		 */			
		private function filterElement (element :*, index:int, tableau:Array):Boolean
		{    
			return element.calorie >= 50;   
		}
			

		/**
		 * Fonction de navigation passée en paramètre d'un tableau
		 * La fonction de navigation est exécutée jusqu'à ce qu'elle renvoie true.
		 * 
		 * Permet de savoir si un élément existe au moins une fois dans un tableau
		 * Renvoie true si il y a au moins une femme dans le tableau.
		 * 
		 * @param element : l'élément du tableau en cours de lecture.
		 * @param index : la position de l'élément dans le tableau.
		 * @param tableau : le tableau complet.
		 * 
		 */					
		private function searchFemme (element :*, index:int, tableau:Array):Boolean
		{
			return (element.sexe == 'F');   
		}	
		
		
			
		/**
		 * Création d'un champ texte.
		 * 
		 */
		private function addText(sValue:String) : UITextField
		{
			var oTxtField:UITextField = new UITextField();
			oTxtField.text = sValue;
			oTxtField.selectable = false;
			oTxtField.autoSizeLeft();
			oTxtField.changeFormat("size", 13);// changement de la taille de la police du texte
			oTxtField.changeFormat("font", "Arial");// changement de la taille de la police du texte
			oTxtField.changeFormat("color", Math.random() *0X006f77);// changement de la couleur
			
			return oTxtField;	 
		}
		
	}

}